package org.pentaho.platform.plugin.action.lego;

import java.io.BufferedOutputStream;
import java.io.InputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

import org.pentaho.commons.connection.IPentahoResultSet;

public class LegoPojo {
	
  public IPentahoResultSet input;
  public boolean demo = false;
  
  
  public void setInput(IPentahoResultSet input) {
    this.input = input;
  }
  
  public void setDemo(boolean demo) {
	  this.demo = demo;
  }
  
  public boolean execute() {
    if (demo) {
    	int vals[] = new int[6];
    	for (int i = 0; i < input.getRowCount(); i++) {
        	if (input.getValueAt(i,0) != null && input.getValueAt(i,0).toString().equalsIgnoreCase("SLEEP")) {
        		System.out.println("SLEEP: " + (int)Double.parseDouble(input.getValueAt(i, 1).toString()));
        		try {
        			Thread.sleep((int)Double.parseDouble(input.getValueAt(i, 1).toString()));
        		} catch (Exception e) {
        			e.printStackTrace();
        		}
        	} else if (input.getValueAt(i,0) != null && input.getValueAt(i,0).toString().equalsIgnoreCase("UPDATE")) {
        		System.out.println("UPDATE");
        		 for (int j = 0; j < 5; j++) {
        		      vals[j] = (int)Double.parseDouble(input.getValueAt(i, j + 1).toString());
        		 }
        		 try {
    		        sendData(vals);
        		 } catch (Exception e) {
    		        e.printStackTrace();
    		     }
        	}
        }
    } else {
	    int vals[] = new int[5];
	    
	    for (int i = 0; i < input.getRowCount(); i++) {
	      int index = ((Long)input.getValueAt(i, 0)).intValue();
	      if (index >= 0 && index < 5) {
	        vals[index] = ((Long)input.getValueAt(i, 1)).intValue();
	      }
	    }
	    try {
	      sendData(vals);
	    } catch (Exception e) {
	      e.printStackTrace();
	    }
    }
    return true;
  }
  
  private static void sendData(int data[]) throws Exception {
    Socket socket = new Socket("localhost", 4444);
    ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(socket.getOutputStream()));
    
    oos.writeObject(data);
    oos.flush();
    
    InputStream ois = socket.getInputStream();
    
    while (ois.available() <= 0) {
      System.out.println("client waiting...");
      Thread.sleep(1000);
    }
    
    ois.close();
    oos.close();
    
    socket.close();
    
    System.out.println("client complete");
 
  }
  
}
